/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.119 Revision 1.149
1# Copyright 1999-2012 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.119 2012/02/28 18:19:29 pesa Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.149 2013/08/13 10:05:37 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Qt herd <qt@gentoo.org> 7# Qt herd <qt@gentoo.org>
8# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass contains various functions that are used when building Qt4. 10# This eclass contains various functions that are used when building Qt4.
11 11
12case ${EAPI} in
13 4|5) : ;;
14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
16
12inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.digia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
13 28
14MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
15MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
16 31
17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/" 32case ${QT4_BUILD_TYPE} in
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 33 live)
19LICENSE="|| ( LGPL-2.1 GPL-3 )" 34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
37 ;;
38 release)
39 SRC_URI="http://download.qt-project.org/official_releases/qt/${PV%.*}/${PV}/${MY_P}.tar.gz"
40 ;;
41esac
20 42
21IUSE="aqua debug pch" 43IUSE="aqua debug pch"
44[[ ${CATEGORY}/${PN} != dev-qt/qtwebkit ]] && IUSE+=" c++0x"
45[[ ${CATEGORY}/${PN} != dev-qt/qtxmlpatterns ]] && IUSE+=" +exceptions"
22 46
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && 47DEPEND="virtual/pkgconfig"
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] && 48if [[ ${QT4_BUILD_TYPE} == live ]]; then
25 IUSE+=" +exceptions" 49 DEPEND+=" dev-lang/perl"
26
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
29fi 50fi
30
31DEPEND="dev-util/pkgconfig"
32RDEPEND="
33 !<x11-libs/qt-assistant-${PV}
34 !>x11-libs/qt-assistant-${PV}-r9999
35 !<x11-libs/qt-core-${PV}
36 !>x11-libs/qt-core-${PV}-r9999
37 !<x11-libs/qt-dbus-${PV}
38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
41 !<x11-libs/qt-demo-${PV}
42 !>x11-libs/qt-demo-${PV}-r9999
43 !<x11-libs/qt-gui-${PV}
44 !>x11-libs/qt-gui-${PV}-r9999
45 !<x11-libs/qt-multimedia-${PV}
46 !>x11-libs/qt-multimedia-${PV}-r9999
47 !<x11-libs/qt-opengl-${PV}
48 !>x11-libs/qt-opengl-${PV}-r9999
49 !<x11-libs/qt-openvg-${PV}
50 !>x11-libs/qt-openvg-${PV}-r9999
51 !<x11-libs/qt-phonon-${PV}
52 !>x11-libs/qt-phonon-${PV}-r9999
53 !<x11-libs/qt-qt3support-${PV}
54 !>x11-libs/qt-qt3support-${PV}-r9999
55 !<x11-libs/qt-script-${PV}
56 !>x11-libs/qt-script-${PV}-r9999
57 !<x11-libs/qt-sql-${PV}
58 !>x11-libs/qt-sql-${PV}-r9999
59 !<x11-libs/qt-svg-${PV}
60 !>x11-libs/qt-svg-${PV}-r9999
61 !<x11-libs/qt-test-${PV}
62 !>x11-libs/qt-test-${PV}-r9999
63 !<x11-libs/qt-webkit-${PV}
64 !>x11-libs/qt-webkit-${PV}-r9999
65 !<x11-libs/qt-xmlpatterns-${PV}
66 !>x11-libs/qt-xmlpatterns-${PV}-r9999
67"
68 51
69S=${WORKDIR}/${MY_P} 52S=${WORKDIR}/${MY_P}
70 53
71# @FUNCTION: qt4-build_pkg_setup 54# @FUNCTION: qt4-build_pkg_setup
72# @DESCRIPTION: 55# @DESCRIPTION:
73# Sets up PATH and LD_LIBRARY_PATH. 56# Sets up PATH and LD_LIBRARY_PATH.
74qt4-build_pkg_setup() { 57qt4-build_pkg_setup() {
75 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
76
77 # Protect users by not allowing downgrades between releases 58 # Protect users by not allowing downgrades between releases.
78 # Downgrading revisions within the same release should be allowed 59 # Downgrading revisions within the same release should be allowed.
79 if has_version '>'${CATEGORY}/${P}-r9999; then 60 if has_version ">${CATEGORY}/${P}-r9999:4"; then
80 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 61 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
81 eerror "Sanity check to keep you from breaking your system:" 62 eerror " *** Sanity check to keep you from breaking your system ***"
82 eerror " Downgrading Qt is completely unsupported and will break your system!" 63 eerror "Downgrading Qt is completely unsupported and will break your system!"
83 die "aborting to save your system" 64 die "aborting to save your system"
84 else 65 else
85 ewarn "Downgrading Qt is completely unsupported and will break your system!" 66 ewarn "Downgrading Qt is completely unsupported and will break your system!"
86 fi 67 fi
87 fi
88
89 if [[ ${PN} == "qt-webkit" ]]; then
90 eshopts_push -s extglob
91 if is-flagq '-g?(gdb)?([1-9])'; then
92 echo
93 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
94 ewarn "You may experience really long compilation times and/or increased memory usage."
95 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
96 ewarn "For more info check out bug #307861"
97 echo
98 fi
99 eshopts_pop
100 fi 68 fi
101 69
102 PATH="${S}/bin${PATH:+:}${PATH}" 70 PATH="${S}/bin${PATH:+:}${PATH}"
103 if [[ ${CHOST} != *-darwin* ]]; then 71 if [[ ${CHOST} != *-darwin* ]]; then
104 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 72 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
109 # avoid extract failure. 77 # avoid extract failure.
110 [[ ${CHOST} == *-apple-darwin* ]] && \ 78 [[ ${CHOST} == *-apple-darwin* ]] && \
111 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 79 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
112 ${QT4_EXTRACT_DIRECTORIES}" 80 ${QT4_EXTRACT_DIRECTORIES}"
113 fi 81 fi
114
115 # Make sure ebuilds use the required EAPI
116 if [[ ${EAPI} != [234] ]]; then
117 eerror "The qt4-build eclass requires EAPI 2,3 or 4 but this ebuild is using"
118 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
119 eerror "fixed. Using qt4-build eclass without EAPI 2,3 or 4 will fail."
120 die "qt4-build eclass requires EAPI 2,3 or 4"
121 fi
122
123 if ! version_is_at_least 4.1 $(gcc-version); then
124 ewarn "Using a GCC version lower than 4.1 is not supported!"
125 fi
126} 82}
83
84# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
85# @DEFAULT_UNSET
86# @DESCRIPTION:
87# Space-separated list including the directories that will be extracted from
88# Qt tarball.
127 89
128# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 90# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
91# @DEFAULT_UNSET
129# @DESCRIPTION: 92# @DESCRIPTION:
130# Arguments for build_target_directories. Takes the directories in which the 93# Arguments for build_target_directories. Takes the directories in which the
131# code should be compiled. This is a space-separated list. 94# code should be compiled. This is a space-separated list.
132
133# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
134# @DESCRIPTION:
135# Space-separated list including the directories that will be extracted from
136# Qt tarball.
137 95
138# @FUNCTION: qt4-build_src_unpack 96# @FUNCTION: qt4-build_src_unpack
139# @DESCRIPTION: 97# @DESCRIPTION:
140# Unpacks the sources. 98# Unpacks the sources.
141qt4-build_src_unpack() { 99qt4-build_src_unpack() {
142 setqtenv 100 setqtenv
143 101
102 if ! version_is_at_least 4.1 $(gcc-version); then
103 ewarn "Using a GCC version lower than 4.1 is not supported."
104 elif use_if_iuse c++0x && ! version_is_at_least 4.4 $(gcc-version); then
105 ewarn "USE=c++0x requires GCC 4.4 or later."
106 fi
107
108 if [[ ${CATEGORY}/${PN} == dev-qt/qtwebkit ]]; then
109 eshopts_push -s extglob
110 if is-flagq '-g?(gdb)?([1-9])'; then
111 echo
112 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
113 ewarn "You may experience really long compilation times and/or increased memory usage."
114 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
115 ewarn "For more info check out https://bugs.gentoo.org/307861"
116 echo
117 fi
118 eshopts_pop
119 fi
120
121 case ${QT4_BUILD_TYPE} in
122 live)
123 git-2_src_unpack
124 ;;
125 release)
144 local tarball="${MY_P}.tar.gz" target= targets= 126 local tarball="${MY_P}.tar.gz" target= targets=
145 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 127 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
146 src/{qbase,qt_targets,qt_install}.pri bin config.tests \ 128 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
147 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES} 129 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
148 do 130 do
149 targets+="${MY_P}/${target} " 131 targets+="${MY_P}/${target} "
150 done 132 done
151 133
152 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/} 134 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
153 tar -xzf "${DISTDIR}/${tarball}" ${targets} 135 tar -xzf "${DISTDIR}/${tarball}" ${targets}
154 eend $? || die "failed to unpack" 136 eend $? || die "failed to unpack"
137 ;;
138 esac
155} 139}
156 140
157# @ECLASS-VARIABLE: PATCHES 141# @ECLASS-VARIABLE: PATCHES
158# @DEFAULT_UNSET 142# @DEFAULT_UNSET
159# @DESCRIPTION: 143# @DESCRIPTION:
160# PATCHES array variable containing all various patches to be applied. 144# PATCHES array variable containing all various patches to be applied.
161# This variable is expected to be defined in global scope of ebuild. 145# This variable is expected to be defined in global scope of ebuild.
162# Make sure to specify the full path. This variable is utilised in 146# Make sure to specify the full path. This variable is utilised in
163# src_unpack/src_prepare phase, based on EAPI. 147# src_prepare() phase.
164# 148#
165# @CODE 149# @CODE
166# PATCHES=( "${FILESDIR}/mypatch.patch" 150# PATCHES=( "${FILESDIR}/mypatch.patch"
167# "${FILESDIR}/patches_folder/" ) 151# "${FILESDIR}/patches_folder/" )
168# @CODE 152# @CODE
169 153
170# @FUNCTION: qt4-build_src_prepare 154# @FUNCTION: qt4-build_src_prepare
171# @DESCRIPTION: 155# @DESCRIPTION:
172# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 156# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
173# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf. 157# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in make.conf.
174qt4-build_src_prepare() { 158qt4-build_src_prepare() {
175 setqtenv 159 setqtenv
176 cd "${S}"
177 160
178 if version_is_at_least "4.7"; then 161 if [[ ${QT4_BUILD_TYPE} == live ]]; then
162 QTDIR="." ./bin/syncqt || die "syncqt failed"
163 fi
164
179 # fix libX11 dependency on non X packages 165 # avoid X11 dependency in non-gui packages
180 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 166 local nolibx11_pkgs="qtcore qtdbus qtscript qtsql qttest qtxmlpatterns"
181 has ${PN} ${nolibx11_pkgs} && qt_nolibx11 167 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
182
183 qt_assistant_cleanup
184 fi
185 168
186 if use aqua; then 169 if use aqua; then
187 # provide a proper macx-g++-64 170 # provide a proper macx-g++-64
188 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 171 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
189 172
190 sed -e '/^CONFIG/s:app_bundle::' \ 173 sed -e '/^CONFIG/s:app_bundle::' \
191 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 174 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
192 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 175 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
193 fi 176 fi
194 177
195 if [[ ${PN} != qt-core ]]; then 178 if [[ ${CATEGORY}/${PN} != dev-qt/qtcore ]]; then
196 skip_qmake_build 179 skip_qmake_build
197 skip_project_generation 180 skip_project_generation
198 symlink_binaries_to_buildtree 181 symlink_binaries_to_buildtree
199 fi 182 fi
200 183
201 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 184 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
202 # qmake bus errors with -O2 but -O3 works 185 # qmake bus errors with -O2 or -O3 but -O1 works
186 # Bug 373061
203 replace-flags -O2 -O3 187 replace-flags -O[23] -O1
204 fi
205
206 # Bug 178652
207 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
208 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
209 append-flags -fno-gcse
210 fi 188 fi
211 189
212 if use_if_iuse c++0x; then 190 if use_if_iuse c++0x; then
213 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
214 ewarn "this is an official standard, some of the reverse dependencies"
215 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
216 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
217 ewarn "disabled."
218 append-flags -std=c++0x 191 append-cxxflags -std=c++0x
219 fi
220
221 # Unsupported old gcc versions - hardened needs this :(
222 if [[ $(gcc-major-version) -lt 4 ]] ; then
223 ewarn "Appending -fno-stack-protector to CXXFLAGS"
224 append-cxxflags -fno-stack-protector
225 # Bug 253127
226 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
227 -i mkspecs/common/g++.conf || die
228 fi 192 fi
229 193
230 # Bug 261632 194 # Bug 261632
231 if use ppc64; then 195 if use ppc64; then
232 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 196 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
237 sed -e "/^SYSTEM_VARIABLES=/i \ 201 sed -e "/^SYSTEM_VARIABLES=/i \
238 CC='$(tc-getCC)'\n\ 202 CC='$(tc-getCC)'\n\
239 CXX='$(tc-getCXX)'\n\ 203 CXX='$(tc-getCXX)'\n\
240 CFLAGS='${CFLAGS}'\n\ 204 CFLAGS='${CFLAGS}'\n\
241 CXXFLAGS='${CXXFLAGS}'\n\ 205 CXXFLAGS='${CXXFLAGS}'\n\
242 LDFLAGS='${LDFLAGS}'\n" \ 206 LDFLAGS='${LDFLAGS}'\n\
207 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
208 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
209 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
210 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
211 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
212 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
243 -i configure \ 213 -i configure \
244 || die "sed SYSTEM_VARIABLES failed" 214 || die "sed SYSTEM_VARIABLES failed"
245 215
246 # Respect CC, CXX, LINK and *FLAGS in config.tests 216 # Respect CC, CXX, LINK and *FLAGS in config.tests
247 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \ 217 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
248 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \ 218 sed -i -e "/bin\/qmake/ s: \"\$SRCDIR/: \
249 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \ 219 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
250 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \ 220 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
251 || die "sed config.tests failed" 221 || die "sed config.tests failed"
252 222
253 # Strip predefined CFLAGS from mkspecs (bug 312689)
254 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
255
256 # Bug 172219 223 # Bug 172219
257 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 224 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
258 225
259 if [[ ${CHOST} == *-darwin* ]]; then 226 if [[ ${CHOST} == *-darwin* ]]; then
260 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 227 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
261 # crippled (by design) :/ 228 # crippled (by design) :/
229 local mac_gpp_conf=
230 if [[ -f mkspecs/common/mac-g++.conf ]]; then
231 # qt < 4.8 has mac-g++.conf
232 mac_gpp_conf="mkspecs/common/mac-g++.conf"
233 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
234 # qt >= 4.8 has g++-macx.conf
235 mac_gpp_conf="mkspecs/common/g++-macx.conf"
236 else
237 die "no known conf file for mac found"
238 fi
262 sed \ 239 sed \
263 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 240 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
264 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 241 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
265 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 242 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
266 -e "s:-arch\s\w*::g" \ 243 -e "s:-arch\s\w*::g" \
267 -i mkspecs/common/mac-g++.conf \ 244 -i ${mac_gpp_conf} \
268 || die "sed mkspecs/common/mac-g++.conf failed" 245 || die "sed ${mac_gpp_conf} failed"
269 246
270 # Fix configure's -arch settings that appear in qmake/Makefile and also 247 # Fix configure's -arch settings that appear in qmake/Makefile and also
271 # fix arch handling (automagically duplicates our -arch arg and breaks 248 # fix arch handling (automagically duplicates our -arch arg and breaks
272 # pch). Additionally disable Xarch support. 249 # pch). Additionally disable Xarch support.
250 local mac_gcc_confs="${mac_gpp_conf}"
251 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
252 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
253 fi
273 sed \ 254 sed \
274 -e "s:-arch i386::" \ 255 -e "s:-arch i386::" \
275 -e "s:-arch ppc::" \ 256 -e "s:-arch ppc::" \
276 -e "s:-arch x86_64::" \ 257 -e "s:-arch x86_64::" \
277 -e "s:-arch ppc64::" \ 258 -e "s:-arch ppc64::" \
278 -e "s:-arch \$i::" \ 259 -e "s:-arch \$i::" \
279 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 260 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
280 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 261 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
281 -e "s:-Xarch_x86_64::g" \ 262 -e "s:-Xarch_x86_64::g" \
282 -e "s:-Xarch_ppc64::g" \ 263 -e "s:-Xarch_ppc64::g" \
283 -i configure mkspecs/common/mac-g++.conf \ 264 -i configure ${mac_gcc_confs} \
284 || die "sed -arch/-Xarch failed" 265 || die "sed -arch/-Xarch failed"
285 266
286 # On Snow Leopard don't fall back to 10.5 deployment target. 267 # On Snow Leopard don't fall back to 10.5 deployment target.
287 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 268 if [[ ${CHOST} == *-apple-darwin10 ]]; then
288 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 269 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
289 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 270 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
290 -i configure mkspecs/common/mac-g++.conf \ 271 -i configure ${mac_gpp_conf} \
291 || die "sed deployment target failed" 272 || die "sed deployment target failed"
292 fi 273 fi
293 fi 274 fi
294 275
295 # this one is needed for all systems with a separate -liconv, apart from 276 # this one is needed for all systems with a separate -liconv, apart from
296 # Darwin, for which the sources already cater for -liconv 277 # Darwin, for which the sources already cater for -liconv
297 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 278 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
298 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \ 279 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
299 -i config.tests/unix/iconv/iconv.pro \ 280 -i config.tests/unix/iconv/iconv.pro \
300 || die "sed iconv.pro failed" 281 || die "sed iconv.pro failed"
301 fi 282 fi
302 283
307 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 288 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
308 # do not flirt with non-Prefix stuff, we're quite possessive 289 # do not flirt with non-Prefix stuff, we're quite possessive
309 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 290 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
310 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 291 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
311 292
312 base_src_prepare 293 # apply patches
294 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
295 epatch_user
313} 296}
314 297
315# @FUNCTION: qt4-build_src_configure 298# @FUNCTION: qt4-build_src_configure
316# @DESCRIPTION: 299# @DESCRIPTION:
317# Default configure phase 300# Default configure phase
318qt4-build_src_configure() { 301qt4-build_src_configure() {
319 setqtenv 302 setqtenv
320 myconf="$(standard_configure_options) ${myconf}" 303
304 local conf="
305 -prefix ${QTPREFIXDIR}
306 -bindir ${QTBINDIR}
307 -libdir ${QTLIBDIR}
308 -docdir ${QTDOCDIR}
309 -headerdir ${QTHEADERDIR}
310 -plugindir ${QTPLUGINDIR}
311 -importdir ${QTIMPORTDIR}
312 -datadir ${QTDATADIR}
313 -translationdir ${QTTRANSDIR}
314 -sysconfdir ${QTSYSCONFDIR}
315 -examplesdir ${QTEXAMPLESDIR}
316 -demosdir ${QTDEMOSDIR}
317 -opensource -confirm-license
318 -shared -fast -largefile -stl -verbose
319 -nomake examples -nomake demos"
320
321 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
322 # $(tc-arch). Therefore we convert it to supported values.
323 case "$(tc-arch)" in
324 amd64|x64-*) conf+=" -arch x86_64" ;;
325 ppc-macos) conf+=" -arch ppc" ;;
326 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
327 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
328 x86-macos) conf+=" -arch x86" ;;
329 x86|x86-*) conf+=" -arch i386" ;;
330 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
331 hppa|sh) conf+=" -arch generic" ;;
332 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
333 esac
334
335 conf+=" -platform $(qt_mkspecs_dir)"
336
337 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
338
339 # debug/release
340 if use debug; then
341 conf+=" -debug"
342 else
343 conf+=" -release"
344 fi
345 conf+=" -no-separate-debug-info"
346
347 # exceptions USE flag
348 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
349
350 # disable rpath (bug 380415), except on prefix (bug 417169)
351 use prefix || conf+=" -no-rpath"
352
353 # precompiled headers don't work on hardened, where the flag is masked
354 conf+=" $(qt_use pch)"
355
356 # -reduce-relocations
357 # This flag seems to introduce major breakage to applications,
358 # mostly to be seen as a core dump with the message "QPixmap: Must
359 # construct a QApplication before a QPaintDevice" on Solaris.
360 # -- Daniel Vergien
361 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
321 362
322 # this one is needed for all systems with a separate -liconv, apart from 363 # this one is needed for all systems with a separate -liconv, apart from
323 # Darwin, for which the sources already cater for -liconv 364 # Darwin, for which the sources already cater for -liconv
324 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 365 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
325 myconf+=" -liconv" 366 conf+=" -liconv"
367 fi
326 368
327 if use_if_iuse glib; then 369 if use_if_iuse glib; then
328 # use -I, -L and -l from configure
329 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 370 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
330 # avoid the -pthread argument 371 # avoid the -pthread argument
331 myconf+=" ${glibflags//-pthread}" 372 conf+=" ${glibflags//-pthread}"
332 unset glibflags 373 unset glibflags
333 fi 374 fi
334 375
335 if use_if_iuse qpa; then
336 ewarn
337 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
338 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
339 ewarn "disable it before reporting any bugs related to this useflag."
340 ewarn
341 myconf+=" -qpa"
342 fi
343
344 if use aqua ; then 376 if use aqua; then
345 # On (snow) leopard use the new (frameworked) cocoa code. 377 # On (snow) leopard use the new (frameworked) cocoa code.
346 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 378 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
347 myconf+=" -cocoa -framework" 379 conf+=" -cocoa -framework"
380 # We need the source's headers, not the installed ones.
381 conf+=" -I${S}/include"
382 # Add hint for the framework location.
383 conf+=" -F${QTLIBDIR}"
348 384
349 # We are crazy and build cocoa + qt3support :-) 385 # We are crazy and build cocoa + qt3support :-)
350 if use qt3support; then 386 if use qt3support; then
351 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 387 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
352 -i configure || die 388 -i configure || die
353 fi 389 fi
354 390 else
355 # We need the source's headers, not the installed ones. 391 conf+=" -no-framework"
356 myconf+=" -I${S}/include"
357
358 # Add hint for the framework location.
359 myconf+=" -F${QTLIBDIR}"
360 fi 392 fi
361 else 393 else
362 # freetype2 include dir is non-standard, thus include it on configure 394 # freetype2 include dir is non-standard, thus pass it to configure
363 # use -I from configure
364 myconf+=" $(pkg-config --cflags freetype2)" 395 conf+=" $(pkg-config --cflags-only-I freetype2)"
365 fi 396 fi
366 397
398 conf+=" ${myconf}"
399 myconf=
400
367 echo ./configure ${myconf} 401 echo ./configure ${conf}
368 ./configure ${myconf} || die "./configure failed" 402 ./configure ${conf} || die "./configure failed"
369 myconf=""
370 403
371 prepare_directories ${QT4_TARGET_DIRECTORIES} 404 prepare_directories ${QT4_TARGET_DIRECTORIES}
372} 405}
373 406
374# @FUNCTION: qt4-build_src_compile 407# @FUNCTION: qt4-build_src_compile
383# @FUNCTION: qt4-build_src_test 416# @FUNCTION: qt4-build_src_test
384# @DESCRIPTION: 417# @DESCRIPTION:
385# Runs tests only in target directories. 418# Runs tests only in target directories.
386qt4-build_src_test() { 419qt4-build_src_test() {
387 # QtMultimedia does not have any test suite (bug #332299) 420 # QtMultimedia does not have any test suite (bug #332299)
388 [[ ${PN} == "qt-multimedia" ]] && return 421 [[ ${CATEGORY}/${PN} == dev-qt/qtmultimedia ]] && return
389 422
390 for dir in ${QT4_TARGET_DIRECTORIES}; do 423 for dir in ${QT4_TARGET_DIRECTORIES}; do
391 emake -j1 check -C ${dir} 424 emake -j1 check -C ${dir}
392 done 425 done
393} 426}
395# @FUNCTION: fix_includes 428# @FUNCTION: fix_includes
396# @DESCRIPTION: 429# @DESCRIPTION:
397# For MacOS X we need to add some symlinks when frameworks are 430# For MacOS X we need to add some symlinks when frameworks are
398# being used, to avoid complications with some more or less stupid packages. 431# being used, to avoid complications with some more or less stupid packages.
399fix_includes() { 432fix_includes() {
400 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 433 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
434 local frw dest f h rdir
401 # Some packages tend to include <Qt/...> 435 # Some packages tend to include <Qt/...>
402 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 436 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
403 437
404 # Fake normal headers when frameworks are installed... eases life later on 438 # Fake normal headers when frameworks are installed... eases life later
405 local dest f h 439 # on, make sure we use relative links though, as some ebuilds assume
440 # these dirs exist in src_install to add additional files
441 f=${QTHEADERDIR}
442 h=${QTLIBDIR}
443 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
444 f=${f#*/}
445 h=${h#*/}
446 done
447 rdir=${h}
448 f="../"
449 while [[ ${h} == */* ]] ; do
450 f="${f}../"
451 h=${h#*/}
452 done
453 rdir="${f}${rdir}"
454
406 for frw in "${D}${QTLIBDIR}"/*.framework; do 455 for frw in "${D}${QTLIBDIR}"/*.framework; do
407 [[ -e "${frw}"/Headers ]] || continue 456 [[ -e "${frw}"/Headers ]] || continue
408 f=$(basename ${frw}) 457 f=$(basename ${frw})
409 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 458 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
410 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 459 dosym "${rdir}"/${f}/Headers "${dest}"
411 460
412 # Link normal headers as well. 461 # Link normal headers as well.
413 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 462 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
414 h=$(basename ${hdr}) 463 h=$(basename ${hdr})
415 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 464 dosym "../${rdir}"/${f}/Headers/${h} \
465 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
416 done 466 done
417 done 467 done
418 fi 468 fi
419} 469}
420 470
421# @FUNCTION: qt4-build_src_install 471# @FUNCTION: qt4-build_src_install
422# @DESCRIPTION: 472# @DESCRIPTION:
423# Perform the actual installation including some library fixes. 473# Perform the actual installation including some library fixes.
424qt4-build_src_install() { 474qt4-build_src_install() {
425 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
426 setqtenv 475 setqtenv
427 476
428 install_directories ${QT4_TARGET_DIRECTORIES} 477 install_directories ${QT4_TARGET_DIRECTORIES}
429 install_qconfigs 478 install_qconfigs
430 fix_library_files 479 fix_library_files
431 fix_includes 480 fix_includes
432 481
433 # remove .la files since we are building only shared Qt libraries 482 # remove .la files since we are building only shared libraries
434 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f 483 prune_libtool_files
435} 484}
436 485
437# @FUNCTION: setqtenv 486# @FUNCTION: setqtenv
438# @INTERNAL 487# @INTERNAL
439setqtenv() { 488setqtenv() {
440 # Set up installation directories 489 # Set up installation directories
441 QTPREFIXDIR=${EPREFIX}/usr 490 QTPREFIXDIR=${EPREFIX}/usr
442 QTBINDIR=${EPREFIX}/usr/bin 491 QTBINDIR=${QTPREFIXDIR}/bin
443 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 492 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
444 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 493 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
445 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 494 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
446 QTHEADERDIR=${EPREFIX}/usr/include/qt4 495 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
447 QTPLUGINDIR=${QTLIBDIR}/plugins 496 QTPLUGINDIR=${QTLIBDIR}/plugins
448 QTIMPORTDIR=${QTLIBDIR}/imports 497 QTIMPORTDIR=${QTLIBDIR}/imports
449 QTDATADIR=${EPREFIX}/usr/share/qt4 498 QTDATADIR=${QTPREFIXDIR}/share/qt4
450 QTTRANSDIR=${QTDATADIR}/translations 499 QTTRANSDIR=${QTDATADIR}/translations
451 QTSYSCONFDIR=${EPREFIX}/etc/qt4 500 QTSYSCONFDIR=${EPREFIX}/etc/qt4
452 QTEXAMPLESDIR=${QTDATADIR}/examples 501 QTEXAMPLESDIR=${QTDATADIR}/examples
453 QTDEMOSDIR=${QTDATADIR}/demos 502 QTDEMOSDIR=${QTDATADIR}/demos
454 QMAKE_LIBDIR_QT=${QTLIBDIR} 503 QMAKE_LIBDIR_QT=${QTLIBDIR}
455 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
456 504
457 PLATFORM=$(qt_mkspecs_dir) 505 PLATFORM=$(qt_mkspecs_dir)
458
459 unset QMAKESPEC 506 unset QMAKESPEC
460}
461 507
462# @FUNCTION: standard_configure_options 508 export XDG_CONFIG_HOME="${T}"
463# @INTERNAL
464# @DESCRIPTION:
465# Sets up some standard configure options, like libdir (if necessary), whether
466# debug info is wanted or not.
467standard_configure_options() {
468 local myconf="-prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
469 -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR}
470 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
471 -datadir ${QTDATADIR} -translationdir ${QTTRANSDIR} -sysconfdir ${QTSYSCONFDIR}
472 -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}
473 -opensource -confirm-license -shared -fast -largefile -stl -verbose
474 -platform $(qt_mkspecs_dir) -nomake examples -nomake demos"
475
476 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
477
478 # debug/release
479 if use debug; then
480 myconf+=" -debug"
481 else
482 myconf+=" -release"
483 fi
484 myconf+=" -no-separate-debug-info"
485
486 # exceptions USE flag
487 local exceptions="-exceptions"
488 in_iuse exceptions && exceptions="$(qt_use exceptions)"
489 myconf+=" ${exceptions}"
490
491 # disable RPATH on Qt >= 4.8 (bug 380415)
492 version_is_at_least 4.8 && myconf+=" -no-rpath"
493
494 # precompiled headers don't work on hardened, where the flag is masked
495 myconf+=" $(qt_use pch)"
496
497 # -reduce-relocations
498 # This flag seems to introduce major breakage to applications,
499 # mostly to be seen as a core dump with the message "QPixmap: Must
500 # construct a QApplication before a QPaintDevice" on Solaris.
501 # -- Daniel Vergien
502 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
503
504 use aqua && myconf+=" -no-framework"
505
506 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
507 # $(tc-arch). Therefore we convert it to supported values.
508 case "$(tc-arch)" in
509 amd64|x64-*) myconf+=" -arch x86_64" ;;
510 ppc-macos) myconf+=" -arch ppc" ;;
511 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
512 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
513 x86-macos) myconf+=" -arch x86" ;;
514 x86|x86-*) myconf+=" -arch i386" ;;
515 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
516 hppa|sh) myconf+=" -arch generic" ;;
517 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
518 esac
519
520 echo "${myconf}"
521} 509}
522 510
523# @FUNCTION: prepare_directories 511# @FUNCTION: prepare_directories
524# @USAGE: < directories > 512# @USAGE: < directories >
525# @INTERNAL 513# @INTERNAL
527# Generates Makefiles for the given list of directories. 515# Generates Makefiles for the given list of directories.
528prepare_directories() { 516prepare_directories() {
529 for x in "$@"; do 517 for x in "$@"; do
530 pushd "${S}"/${x} >/dev/null || die 518 pushd "${S}"/${x} >/dev/null || die
531 einfo "Running qmake in: ${x}" 519 einfo "Running qmake in: ${x}"
532 # avoid running over the maximum argument number, bug #299810 520 "${S}"/bin/qmake \
533 { 521 "LIBS+=-L${QTLIBDIR}" \
534 echo "${S}"/mkspecs/common/*.conf 522 "CONFIG+=nostrip" \
535 find "${S}" -name '*.pr[io]' 523 || die "qmake failed"
536 } | xargs sed -i \
537 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
538 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
539 || die
540 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
541 popd >/dev/null || die 524 popd >/dev/null || die
542 done 525 done
543} 526}
544
545 527
546# @FUNCTION: build_directories 528# @FUNCTION: build_directories
547# @USAGE: < directories > 529# @USAGE: < directories >
548# @INTERNAL 530# @INTERNAL
549# @DESCRIPTION: 531# @DESCRIPTION:
550# Compiles the code in the given list of directories. 532# Compiles the code in the given list of directories.
551build_directories() { 533build_directories() {
552 for x in "$@"; do 534 for x in "$@"; do
553 pushd "${S}"/${x} >/dev/null || die 535 pushd "${S}"/${x} >/dev/null || die
536 emake \
537 AR="$(tc-getAR) cqs" \
554 emake CC="$(tc-getCC)" \ 538 CC="$(tc-getCC)" \
555 CXX="$(tc-getCXX)" \ 539 CXX="$(tc-getCXX)" \
556 LINK="$(tc-getCXX)" || die "emake failed" 540 LINK="$(tc-getCXX)" \
541 RANLIB=":" \
542 STRIP=":"
557 popd >/dev/null || die 543 popd >/dev/null || die
558 done 544 done
559} 545}
560 546
561# @FUNCTION: install_directories 547# @FUNCTION: install_directories
564# @DESCRIPTION: 550# @DESCRIPTION:
565# Runs emake install in the given directories, which are separated by spaces. 551# Runs emake install in the given directories, which are separated by spaces.
566install_directories() { 552install_directories() {
567 for x in "$@"; do 553 for x in "$@"; do
568 pushd "${S}"/${x} >/dev/null || die 554 pushd "${S}"/${x} >/dev/null || die
569 emake INSTALL_ROOT="${D}" install || die "emake install failed" 555 emake INSTALL_ROOT="${D}" install
570 popd >/dev/null || die 556 popd >/dev/null || die
571 done 557 done
572} 558}
573 559
574# @ECLASS-VARIABLE: QCONFIG_ADD 560# @ECLASS-VARIABLE: QCONFIG_ADD
595 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 581 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
596 for x in QCONFIG_ADD QCONFIG_REMOVE; do 582 for x in QCONFIG_ADD QCONFIG_REMOVE; do
597 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 583 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
598 done 584 done
599 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo 585 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
600 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 586 doins "${T}"/${PN}-qconfig.pri
601 fi 587 fi
602 588
603 if [[ -n ${QCONFIG_DEFINE} ]]; then 589 if [[ -n ${QCONFIG_DEFINE} ]]; then
604 for x in ${QCONFIG_DEFINE}; do 590 for x in ${QCONFIG_DEFINE}; do
605 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 591 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
606 done 592 done
607 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo 593 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
608 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 594 doins "${T}"/gentoo-${PN}-qconfig.h
609 fi 595 fi
610} 596}
611 597
612# @FUNCTION: generate_qconfigs 598# @FUNCTION: generate_qconfigs
613# @INTERNAL 599# @INTERNAL
614# @DESCRIPTION: 600# @DESCRIPTION:
615# Generates gentoo-specific qconfig.{h,pri}. 601# Generates gentoo-specific qconfig.{h,pri}.
616generate_qconfigs() { 602generate_qconfigs() {
617 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 603 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == dev-qt/qtcore ]]; then
618 local x qconfig_add qconfig_remove qconfig_new 604 local x qconfig_add qconfig_remove qconfig_new
619 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 605 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
620 [[ -f ${x} ]] || continue 606 [[ -f ${x} ]] || continue
621 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 607 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
622 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 608 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
623 done 609 done
624 610
625 # these error checks do not use die because dying in pkg_post{inst,rm} 611 # these error checks do not use die because dying in pkg_post{inst,rm}
626 # just makes things worse. 612 # just makes things worse.
627 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 613 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
628 # start with the qconfig.pri that qt-core installed 614 # start with the qconfig.pri that qtcore installed
629 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \ 615 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \
630 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 616 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
631 eerror "cp qconfig failed." 617 eerror "cp qconfig failed."
632 return 1 618 return 1
633 fi 619 fi
685} 671}
686 672
687# @FUNCTION: skip_qmake_build 673# @FUNCTION: skip_qmake_build
688# @INTERNAL 674# @INTERNAL
689# @DESCRIPTION: 675# @DESCRIPTION:
690# Patches configure to skip qmake compilation, as it's already installed by qt-core. 676# Patches configure to skip qmake compilation, as it's already installed by qtcore.
691skip_qmake_build() { 677skip_qmake_build() {
692 sed -i -e "s:if true:if false:g" "${S}"/configure || die 678 sed -i -e "s:if true:if false:g" "${S}"/configure || die
693} 679}
694 680
695# @FUNCTION: skip_project_generation 681# @FUNCTION: skip_project_generation
753# @RETURN: the specs-directory w/o path 739# @RETURN: the specs-directory w/o path
754# @DESCRIPTION: 740# @DESCRIPTION:
755# Allows us to define which mkspecs dir we want to use. 741# Allows us to define which mkspecs dir we want to use.
756qt_mkspecs_dir() { 742qt_mkspecs_dir() {
757 local spec= 743 local spec=
744
758 case ${CHOST} in 745 case "${CHOST}" in
759 *-freebsd*|*-dragonfly*) 746 *-freebsd*|*-dragonfly*)
760 spec=freebsd ;; 747 spec=freebsd ;;
761 *-openbsd*) 748 *-openbsd*)
762 spec=openbsd ;; 749 spec=openbsd ;;
763 *-netbsd*) 750 *-netbsd*)
774 *-solaris*) 761 *-solaris*)
775 spec=solaris ;; 762 spec=solaris ;;
776 *-linux-*|*-linux) 763 *-linux-*|*-linux)
777 spec=linux ;; 764 spec=linux ;;
778 *) 765 *)
779 die "Unknown CHOST, no platform chosen" 766 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
780 esac 767 esac
781 768
782 CXX=$(tc-getCXX) 769 case "$(tc-getCXX)" in
783 if [[ ${CXX} == *g++* ]]; then 770 *g++*)
784 spec+=-g++ 771 spec+=-g++ ;;
785 elif [[ ${CXX} == *icpc* ]]; then 772 *icpc*)
786 spec+=-icc 773 spec+=-icc ;;
787 else 774 *)
788 die "Unknown compiler '${CXX}'" 775 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
789 fi 776 esac
790 777
791 # Add -64 for 64bit profiles 778 # Add -64 for 64bit profiles
792 if use x64-freebsd || 779 if use x64-freebsd ||
793 use amd64-linux || 780 use amd64-linux ||
794 use x64-macos || 781 use x64-macos ||
799 fi 786 fi
800 787
801 echo "${spec}" 788 echo "${spec}"
802} 789}
803 790
804# @FUNCTION: qt_assistant_cleanup
805# @INTERNAL
806# @DESCRIPTION:
807# Tries to clean up tools.pro for qt-assistant ebuilds.
808# Meant to be called in src_prepare().
809# Since Qt 4.7.4 this function is a no-op.
810qt_assistant_cleanup() {
811 # apply patching to qt-assistant ebuilds only
812 [[ ${PN} != "qt-assistant" ]] && return
813
814 # no longer needed for 4.7.4 and later
815 version_is_at_least "4.7.4" && return
816
817 # different versions (and branches...) may need different handling,
818 # add a case if you need special handling
819 case "${MY_PV_EXTRA}" in
820 *kde-qt*)
821 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
822 -e "/mac/,/^embedded.*makeqpf$/d" \
823 -i tools/tools.pro || die "patching tools.pro failed"
824 ;;
825 *)
826 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
827 -e "/mac/,/^embedded.*makeqpf$/d" \
828 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
829 -i tools/tools.pro || die "patching tools.pro failed"
830 ;;
831 esac
832}
833
834# @FUNCTION: qt_nolibx11 791# @FUNCTION: qt_nolibx11
835# @INTERNAL 792# @INTERNAL
836# @DESCRIPTION: 793# @DESCRIPTION:
837# Ignore X11 tests for packages that don't need X libraries installed. 794# Skip X11 tests for packages that don't need X libraries installed.
838qt_nolibx11() { 795qt_nolibx11() {
839 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure || 796 sed -i -e '/^if.*PLATFORM_X11.*CFG_GUI/,/^fi$/d' "${S}"/configure || die
840 die "x11 check sed failed"
841} 797}
842 798
843EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 799EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.119  
changed lines
  Added in v.1.149

  ViewVC Help
Powered by ViewVC 1.1.20